<template>
    <div class="modal-background" id="outside_modal">
        <div class="login-modal" id="in_modal">
            <div v-if="!registration_open">
                <div style="text-align: center; color: var(--color-primary); font-weight: bold;">Log in to MetaboSERV</div>
                <div class="login-fields">
                    <span>Username:</span><input type="text" v-model="login_username"/>
                    <span>Password:</span><input type="password" v-model="login_password" @keyup.enter="handleLogin()"/>
                </div>
                <div class="buttons">
                    <button @click="handleLogin()">Login</button>
                </div>
                <div class="internal-link pwf" @click="pwForgotten">Forgot your password?</div>
                <div style="text-align: center; color: var(--color-primary); font-weight: bold; margin-top: 0.5rem;">Or alternatively, use an authorization token:</div>
                <div class="login-fields">
                    <span>Token:</span><input type="text" v-model="login_token"/>
                </div>
                <div class="buttons">
                    <button @click="handleAuthToken()">Use token</button>
                </div>
                <div class="registration-msg" v-if="message">
                    {{message}}
                </div>
                <div style="text-align: center; font-size: var(--fs-small); margin-top: 1rem;">Don't have an account yet? <span class="internal-link" @click="toggleRegistration">Register here.</span></div>
            </div>
            <div v-if="registration_open" style="overflow: hidden;">
                <div style="text-align: center; color: var(--color-primary); font-weight: bold;">Register a MetaboSERV Account</div>
                <div class="login-fields register-fields expanded">
                    <span>Username*:</span><input type="text" v-model="register_username"/>
                    <span>Password*:</span><input type="password" v-model="register_password"/>
                    <span>Password (again)*:</span><input type="password"/>
                    <span>E-mail address*:</span><input type="text" v-model="register_email"/>
                    <span>Institution:</span><input type="text" v-model="register_institution"/>
                </div>
                <div class="buttons">
                    <button @click="handleRegistration()">Register</button>
                    <button @click="registration_open = false">Cancel</button>
                </div>
            </div>
            
        </div>
    </div>
</template>

<script setup lang="ts">
import { onMounted, ref } from 'vue';
import { register, login, token_login, sendRecoveryEmail, recoverPassword } from '@/modules/auth_module';
import { useMessageStore } from '@/stores/message';

const msg = useMessageStore();

const emit = defineEmits<{
    'close-modal': [],
}>();

const toggleRegistration = () => {
    registration_open.value = !registration_open.value;
}

/**
 * Tries to register a MetaboSERV user account.
 */
const handleRegistration = async () => {
    let registration = await register(
        register_username.value,
        register_password.value,
        register_email.value,
        register_institution.value
    );
    msg.add_message({status: registration.status, msg: registration.msg});
    if (registration.status == 200) await new Promise(resolve => setTimeout(resolve, 3000)).then(() => {emit('close-modal');});
}

/**
 * Tries to register a MetaboSERV user account.
 */
 const handleLogin = async () => {
    let login_procedure = await login(
        login_username.value,
        login_password.value,
    );
    if (login_procedure.status == 200) emit('close-modal');
    msg.add_message({status: login_procedure.status, msg: login_procedure.msg});
    
}

/**
 * Tries to "log in" using an authorization token.
 */
const handleAuthToken = async () => {
    let token_procedure = await token_login(
        login_token.value,
    );
    if (token_procedure.status == 200) emit('close-modal');
    msg.add_message({status: token_procedure.status, msg: token_procedure.msg});
}

/**
 * On mounting, sets values for inside and outside the modal and stores them.
 */
 onMounted(() => {
    initialized.value = false;
    if(document.getElementById("in_modal") && document.getElementById("in_modal") != undefined) {
        in_modal.value = document.getElementById("in_modal")
    }
    if(document.getElementById("outside_modal") && document.getElementById("outside_modal") != undefined) {
        outside_modal.value = document.getElementById("outside_modal")
    }
    initialized.value = true;
})

/**
 * Shows the modal if a user clicks inside the modal.
 * Closes it if a user clicks outside the modal.
 */
window.onclick = ((e: MouseEvent): void => {
    if (!initialized) {
        return;
    }
    if ((!in_modal.value || !outside_modal.value) || (e.target == outside_modal.value && e.target != in_modal.value)) {
        emit('close-modal')
    }
});

const pwForgotten = async () => {
    if (!login_username.value) {
        msg.add_message({msg: "Please enter your username into the login window!", status: 400});
        return;
    }
    if (login_username.value == "admin") {
        msg.add_message({msg: "The password for the admin account can not be changed here!", status: 400});
        return;
    }
    await sendRecoveryEmail(login_username.value).then(async (res) => {
        msg.add_message(res);
        if (res.status == 200) {
            const code = prompt("We have sent you an e-mail containing a code to prove your identity. Please enter the code here.");
            if (!code) {
                msg.add_message({msg: "No code was entered! Please try again!", status: 400});
                return;
            } 
            await recoverPassword(login_username.value, code).then((res2) => {
                msg.add_message(res2);
            });
        }
    });
}


const in_modal=ref<HTMLElement | null>();
const outside_modal=ref<HTMLElement | null>();
const initialized=ref(false);
const message=ref<string>("");
const registration_open = ref(false);

const login_username = ref<string>("");
const login_password = ref<string>("");
const login_token = ref<string>("");

const register_username = ref<string>("");
const register_password = ref<string>("");
const register_email = ref<string>("");
const register_institution = ref<string>("");
</script>

<style scoped>

.pwf {
    margin-top: 0.5rem;
    text-align: center;
    font-size: 0.65rem;
}

.login-modal {
    min-width: 30%;
    max-width: 65%;
    min-height: 10rem;
    padding: 1rem;
    margin: auto;
    background: #fff;
    box-shadow: var(--sd-larger);
}

.login-fields {
    display: grid;
    text-align: left;
    align-items: center;
    margin: 1rem 1rem 1rem 0;
    grid-template-columns: 3fr 7fr;
    row-gap: 1rem;
    column-gap: 0.25rem;
    grid-auto-flow: row;
}

.registration-msg {
    text-align: center;
    margin-top: 1rem;
}

</style>
